'use client';

// RULES:
// contains list page for lp_questions (QuizLPQuestions)
// contain definition to collection only
//
import * as React from 'react';
import { useRouter } from 'next/navigation';
import { COL_QUIZ_MF_QUESTIONS } from '@/constants';
import { LoadingButton } from '@mui/lab';
import Box from '@mui/material/Box';
import Card from '@mui/material/Card';
import Divider from '@mui/material/Divider';
import Stack from '@mui/material/Stack';
import Typography from '@mui/material/Typography';
import { Plus as PlusIcon } from '@phosphor-icons/react/dist/ssr/Plus';
import type { ListResult, RecordModel } from 'pocketbase';
import { useTranslation } from 'react-i18next';

import { paths } from '@/paths';
import { logger } from '@/lib/default-logger';
import { pb } from '@/lib/pb';
import { toast } from '@/components/core/toaster';
import ErrorDisplay from '@/components/dashboard/error';
import { defaultMfQuestion } from '@/components/dashboard/mf/questions/_constants';
import { MfQuestionsFilters } from '@/components/dashboard/mf/questions/mf-questions-filters';
import type { Filters } from '@/components/dashboard/mf/questions/mf-questions-filters';
import { MfQuestionsPagination } from '@/components/dashboard/mf/questions/mf-questions-pagination';
import { MfQuestionsSelectionProvider } from '@/components/dashboard/mf/questions/mf-questions-selection-context';
import { MfQuestionsTable } from '@/components/dashboard/mf/questions/mf-questions-table';
import type { MfQuestion } from '@/components/dashboard/mf/questions/type';
import FormLoading from '@/components/loading';

export default function Page({ searchParams }: PageProps): React.JSX.Element {
  const { t } = useTranslation(['lp_questions']);
  const { email, phone, sortDir, status, name, visible, type } = searchParams;
  const router = useRouter();
  const [lessonQuestionsData, setLessonCategoriesData] = React.useState<MfQuestion[]>([]);
  //

  const [isLoadingAddPage, setIsLoadingAddPage] = React.useState<boolean>(false);
  const [showLoading, setShowLoading] = React.useState<boolean>(true);
  const [showError, setShowError] = React.useState({ show: false, detail: '' });
  //
  const [rowsPerPage, setRowsPerPage] = React.useState<number>(5);
  const [f, setF] = React.useState<MfQuestion[]>([]);
  const [currentPage, setCurrentPage] = React.useState<number>(0);
  const [recordCount, setRecordCount] = React.useState<number>(0);
  const [listOption, setListOption] = React.useState({});
  const [listSort, setListSort] = React.useState({});

  //
  const sortedLessonCategories = applySort(lessonQuestionsData, sortDir);
  const filteredLessonCategories = applyFilters(sortedLessonCategories, { email, phone, status });

  const reloadRows = async (): Promise<void> => {
    try {
      const models: ListResult<RecordModel> = await pb
        .collection(COL_QUIZ_MF_QUESTIONS)
        .getList(currentPage + 1, rowsPerPage, listOption);
      const { items, totalItems } = models;
      const tempLessonTypes: MfQuestion[] = items.map((lt) => {
        return { ...defaultMfQuestion, ...lt };
      });

      setLessonCategoriesData(tempLessonTypes);
      setRecordCount(totalItems);
      setF(tempLessonTypes);
      // console.log({ currentPage, f });
    } catch (error) {
      //
      logger.error(error);
      setShowError({
        //
        show: true,
        detail: JSON.stringify(error, null, 2),
      });
    } finally {
      setShowLoading(false);
    }
  };

  const [lastListOption, setLastListOption] = React.useState({});
  const isFirstRun = React.useRef(false);
  React.useEffect(() => {
    if (!isFirstRun.current) {
      isFirstRun.current = true;
    } else {
      if (JSON.stringify(listOption) !== JSON.stringify(lastListOption)) {
        // reset page number as tab changes
        setLastListOption(listOption);
        setCurrentPage(0);
        void reloadRows();
      } else {
        void reloadRows();
      }
    }
  }, [currentPage, rowsPerPage, listOption]);

  React.useEffect(() => {
    let tempFilter = [],
      tempSortDir = '';

    if (visible) {
      tempFilter.push(`visible = "${visible}"`);
    }

    if (sortDir) {
      tempSortDir = `-created`;
    }

    if (name) {
      tempFilter.push(`name ~ "%${name}%"`);
    }

    if (type) {
      tempFilter.push(`type ~ "%${type}%"`);
    }

    let preFinalListOption = {};
    if (tempFilter.length > 0) {
      preFinalListOption = { filter: tempFilter.join(' && ') };
    }
    if (tempSortDir.length > 0) {
      preFinalListOption = { ...preFinalListOption, sort: tempSortDir };
    }
    setListOption(preFinalListOption);
    // setListOption({
    //   filter: tempFilter.join(' && '),
    //   sort: tempSortDir,
    //   //
    // });
  }, [visible, sortDir, name, type]);

  // return <>helloworld</>;

  if (showLoading) return <FormLoading />;

  if (showError.show)
    return (
      <ErrorDisplay
        message={t('error.unable-to-process-request')}
        code={-1}
        details={showError.detail}
      />
    );

  return (
    <Box
      sx={{
        maxWidth: 'var(--Content-maxWidth)',
        m: 'var(--Content-margin)',
        p: 'var(--Content-padding)',
        width: 'var(--Content-width)',
      }}
    >
      <Stack spacing={4}>
        <Stack
          direction={{ xs: 'column', sm: 'row' }}
          spacing={3}
          sx={{ alignItems: 'flex-start' }}
        >
          <Box sx={{ flex: '1 1 auto' }}>
            <Typography variant="h4">{t('list.title')}</Typography>
          </Box>
          <Box sx={{ display: 'flex', justifyContent: 'flex-end' }}>
            <LoadingButton
              loading={isLoadingAddPage}
              onClick={(): void => {
                setIsLoadingAddPage(true);
                router.push(paths.dashboard.lp_questions.create);
              }}
              startIcon={<PlusIcon />}
              variant="contained"
            >
              {t('list.add')}
            </LoadingButton>
          </Box>
        </Stack>
        <MfQuestionsSelectionProvider lessonQuestions={f}>
          <Card>
            <MfQuestionsFilters
              filters={{ email, phone, status, name, visible, type }}
              fullData={lessonQuestionsData}
              sortDir={sortDir}
            />
            <Divider />
            <Box sx={{ overflowX: 'auto' }}>
              <MfQuestionsTable
                reloadRows={reloadRows}
                rows={f}
              />
            </Box>
            <Divider />
            <MfQuestionsPagination
              count={recordCount}
              page={currentPage}
              rowsPerPage={rowsPerPage}
              setPage={setCurrentPage}
              setRowsPerPage={setRowsPerPage}
            />
          </Card>
        </MfQuestionsSelectionProvider>
      </Stack>
      <pre>{JSON.stringify(f, null, 2)}</pre>
    </Box>
  );
}

// Sorting and filtering has to be done on the server.

function applySort(row: MfQuestion[], sortDir: 'asc' | 'desc' | undefined): MfQuestion[] {
  return row.sort((a, b) => {
    if (sortDir === 'asc') {
      return a.createdAt.getTime() - b.createdAt.getTime();
    }

    return b.createdAt.getTime() - a.createdAt.getTime();
  });
}

function applyFilters(row: MfQuestion[], { email, phone, status, name, visible }: Filters): MfQuestion[] {
  return row.filter((item) => {
    if (email) {
      if (!item.email?.toLowerCase().includes(email.toLowerCase())) {
        return false;
      }
    }

    if (phone) {
      if (!item.phone?.toLowerCase().includes(phone.toLowerCase())) {
        return false;
      }
    }

    if (status) {
      if (item.status !== status) {
        return false;
      }
    }

    if (name) {
      if (!item.name?.toLowerCase().includes(name.toLowerCase())) {
        return false;
      }
    }

    if (visible) {
      if (!item.visible?.toLowerCase().includes(visible.toLowerCase())) {
        return false;
      }
    }

    return true;
  });
}

interface PageProps {
  searchParams: {
    email?: string;
    phone?: string;
    sortDir?: 'asc' | 'desc';
    status?: string;
    name?: string;
    visible?: string;
    type?: string;
    //
  };
}
